﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "WeaponInventory.generated.h"


class AWeaponItemClass;

UCLASS(ClassGroup=(Custom), meta=(BlueprintSpawnableComponent))
class ENDLESSVENDETTA_API UWeaponInventory : public UActorComponent
{
	GENERATED_BODY()

public:
	// Sets default values for this component's properties
	UWeaponInventory();

protected:
	// Called when the game starts
	virtual void BeginPlay() override;

	UPROPERTY(VisibleAnywhere, Category = "Weapon System")
	TArray<AWeaponItemClass*> WeaponsArray;

public:
	// Called every frame
	virtual void TickComponent(float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction) override;

	//Using a getter to get the protected weaponsArray
	UFUNCTION()
	TArray<AWeaponItemClass*> GetWeaponArray() const { return WeaponsArray; }

	//Using a Setter to set the protected weapons array to the getter
	UFUNCTION()
	void SetArray(const TArray<AWeaponItemClass*> weaponArray) { WeaponsArray = weaponArray; }
	
private:
	//Called from blueprints from the player
	UFUNCTION(BlueprintCallable)
	void WeaponPickup(AActor* WeaponPickedUp);
};
